package com.ejie.ad74a.service;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.odftoolkit.odfdom.doc.OdfSpreadsheetDocument;
import org.odftoolkit.odfdom.doc.table.OdfTable;
import org.odftoolkit.odfdom.doc.table.OdfTableRow;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import com.ejie.ad74a.constantes.Constantes;
import com.ejie.ad74a.dao.InformeSocialDao;
import com.ejie.ad74a.dao.InformesDao;
import com.ejie.ad74a.exceptions.ManagerErrors;
import com.ejie.ad74a.model.Avisos;
import com.ejie.ad74a.model.ConvivientesInfSoci;
import com.ejie.ad74a.model.DocTemporales;
import com.ejie.ad74a.model.DocuAvisos;
import com.ejie.ad74a.model.DocumentosInforme;
import com.ejie.ad74a.model.Expedientes;
import com.ejie.ad74a.model.InformeSocial;
import com.ejie.ad74a.model.Informes;
import com.ejie.ad74a.model.MaestroActores;
import com.ejie.ad74a.model.MaestroSubtiposAviso;
import com.ejie.ad74a.model.MaestroTiposAviso;
import com.ejie.ad74a.service.documentos.DocumentosService;
import com.ejie.ad74a.util.comun.UtilLiterales;
import com.ejie.ad74a.util.comun.UtilSeguridad;
import com.ejie.ad74a.util.comun.Utilidades;
import com.ejie.ad74a.util.comun.UtilidadesFecha;
import com.ejie.ad74a.util.constantes.ActoresEnum;
import com.ejie.ad74a.util.constantes.EstadoInformesEnum;
import com.ejie.ad74a.util.constantes.SubTipoAvisoEnum;
import com.ejie.ad74a.util.constantes.TipoAvisoEnum;
import com.ejie.ad74a.util.constantes.TipoInformesEnum;
import com.ejie.ad74a.util.constantes.TiposDocumentoRoleEnum;
import com.ejie.ad74a.util.pid.Ad74aPIDws;
import com.ejie.ad74a.util.pif.Ad74aPIFws;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;
import com.lowagie.text.Document;
import com.lowagie.text.Phrase;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;

/**
 * InformesServiceImpl generated by UDA, 19-abr-2023 16:38:34.
 * 
 * @author UDA
 */

@Service(value = "informesService")
public class InformesServiceImpl implements InformesService {

	private static final Logger logger = LoggerFactory.getLogger(InformesServiceImpl.class);

	@Autowired
	private InformesDao informesDao;

	@Autowired
	private InformeSocialDao informeSocialDao;

	@Autowired
	InformeSocialService informeSocialService;

	@Autowired
	ConvivientesInfSociService convivientesInfSociService;

	@Autowired
	private Ad74aPIDws pidWS;

	@Autowired
	DocumentosInformeService documentosInformeService;

	@Autowired
	private AvisosService avisosService;

	@Autowired
	private DocumentosService documentosService;

	@Autowired
	private DocuAvisosService docuAvisosService;

	@Resource
	private ReloadableResourceBundleMessageSource appMessageSource;

	/**
	 * Inserts a single row in the Informes table.
	 *
	 * @param informes Informes
	 * @return Informes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Informes add(Informes informes) {
		return this.informesDao.add(informes);
	}

	/**
	 * Updates a single row in the Informes table.
	 *
	 * @param informes Informes
	 * @return Informes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Informes update(Informes informes) {
		this.informeSocialDao.update(informes.getInformeSocial());
		return this.informesDao.update(informes);
	}

	/**
	 * Finds a single row in the Informes table.
	 *
	 * @param informes Informes
	 * @return Informes
	 */
	public Informes find(Informes informes) {
		return (Informes) this.informesDao.find(informes);
	}

	/**
	 * Deletes a single row in the Informes table.
	 *
	 * @param informes Informes
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(Informes informes) {
		this.informesDao.remove(informes);
	}

	/**
	 * Finds a list of rows in the Informes table.
	 *
	 * @param informes        Informes
	 * @param tableRequestDto TableRequestDto
	 * @return List<Informes>
	 */
	public List<Informes> findAll(Informes informes, TableRequestDto tableRequestDto) {
		return (List<Informes>) this.informesDao.findAll(informes, tableRequestDto);
	}

	/**
	 * Finds a list of rows in the Informes table.
	 *
	 * @param informes        Informes
	 * @param tableRequestDto TableRequestDto
	 * @return List<Informes>
	 */
	public List<Informes> findAllTodosEstados(Informes informes, TableRequestDto tableRequestDto) {
		return (List<Informes>) this.informesDao.findAllTodosEstados(informes, tableRequestDto);
	}

	/**
	 * Finds rows in the Informes table using like.
	 *
	 * @param informes        Informes
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith      Boolean
	 * @return List<Informes>
	 */
	public List<Informes> findAllLike(Informes informes, TableRequestDto tableRequestDto, Boolean startsWith) {

		List<Informes> listaInformes = this.informesDao.findAllLike(informes, tableRequestDto, startsWith);
		for (Informes informe : listaInformes) {
			if (informe.getTipoInforme16().equals("1")) {
				InformeSocial informeSocial = this.informeSocialService
						.find(new InformeSocial(informe.getIdInforme16()));
				informe.setInformeSocial(informeSocial);
			}
		}

		return listaInformes;
	}

	public List<Informes> findAllLikePorUsuario(Informes informes, TableRequestDto tableRequestDto, Boolean startsWith,
			Integer usuario) {

		return this.informesDao.findAllLikePorUsuario(informes, tableRequestDto, false, usuario);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Informes table.
	 *
	 * @param tableRequestDto TableRequestDto
	 */
	public void removeMultiple(TableRequestDto tableRequestDto) {
		this.informesDao.removeMultiple(tableRequestDto);
	}

	/**
	 * Filter method in the Informes table.
	 *
	 * @param filterInformes  Informes
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith      Boolean
	 * @return TableResponseDto<Informes>
	 */
	public TableResponseDto<Informes> filter(Informes filterInformes, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		List<Informes> listaInformes = this.informesDao.findAllLike(filterInformes, tableRequestDto, false);
		Long recordNum = this.informesDao.findAllLikeCount(filterInformes != null ? filterInformes : new Informes(),
				false);

		TableResponseDto<Informes> tableResponseDto = new TableResponseDto<Informes>(tableRequestDto, recordNum,
				listaInformes);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Informes>> reorderSelection = this.informesDao.reorderSelection(filterInformes,
					tableRequestDto, startsWith, null);
			tableResponseDto.setReorderedSelection(reorderSelection);
			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<Informes>> reorderSeeker = this.informesDao.reorderSelection(filterInformes,
					tableRequestDto, startsWith, null);
			tableResponseDto.setReorderedSeeker(reorderSeeker);
			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return tableResponseDto;
	}

	public TableResponseDto<Informes> filterPorUsuario(Informes filterInformes, TableRequestDto tableRequestDto,
			Boolean startsWith, Integer usuario) {
		List<Informes> listaInformes = this.informesDao.findAllLikePorUsuario(filterInformes, tableRequestDto, false,
				usuario);
		Long recordNum = this.informesDao
				.findAllLikeCountPorUsuario(filterInformes != null ? filterInformes : new Informes(), false, usuario);

		TableResponseDto<Informes> tableResponseDto = new TableResponseDto<Informes>(tableRequestDto, recordNum,
				listaInformes);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Informes>> reorderSelection = this.informesDao.reorderSelection(filterInformes,
					tableRequestDto, startsWith, usuario);
			tableResponseDto.setReorderedSelection(reorderSelection);
			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<Informes>> reorderSeeker = this.informesDao.reorderSelection(filterInformes,
					tableRequestDto, startsWith, usuario);
			tableResponseDto.setReorderedSeeker(reorderSeeker);
			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return tableResponseDto;
	}

	/**
	 * Searches rows in the Informes table.
	 *
	 * @param filterInformes  Informes
	 * @param searchInformes  Informes
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith      Boolean
	 * @return List<TableRowDto<Informes>>
	 */
	public List<TableRowDto<Informes>> search(Informes filterInformes, Informes searchInformes,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.informesDao.search(filterInformes, searchInformes, tableRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in Informes table.
	 *
	 * @param filterInformes  Informes
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith      Boolean
	 * @return Object
	 */
	public Object reorderSelection(Informes filterInformes, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.informesDao.reorderSelection(filterInformes, tableRequestDto, startsWith, null);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Informes table.
	 *
	 * @param filterInformes  Informes
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith      Boolean
	 * @return TableResponseDto<JerarquiaDto<Informes>>
	 */
	public TableResponseDto<JerarquiaDto<Informes>> jerarquia(Informes filterInformes, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		List<JerarquiaDto<Informes>> listaInformes = this.informesDao.findAllLikeJerarquia(filterInformes,
				tableRequestDto);
		Long recordNum = this.informesDao.findAllLikeCountJerarquia(filterInformes, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<Informes>>(tableRequestDto, recordNum, listaInformes);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the Informes table.
	 *
	 * @param filterInformes  Informes
	 * @param tableRequestDto TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<Informes>>
	 */
	public TableResponseDto<JerarquiaDto<Informes>> jerarquiaChildren(Informes filterInformes,
			TableRequestDto tableRequestDto) {
		TableResponseDto<JerarquiaDto<Informes>> tableResponseDto = new TableResponseDto<JerarquiaDto<Informes>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN,
				this.informesDao.findAllChild(filterInformes, tableRequestDto));
		return tableResponseDto;
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<Informes> getMultiple(Informes filterInformes, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.informesDao.getMultiple(filterInformes, tableRequestDto, startsWith);
	}

	/**
	 * Devuelve un fichero en el formato deseado que contiene los datos exportados
	 * de la tabla.
	 *
	 * @param filterInformes  Informes
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param reportsParams   ArrayList<?>
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@Override
	public void generateReport(Informes filterInformes, String[] columns, String[] columnsName, String fileName,
			String sheetTitle, TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		// Accede a la DB para recuperar datos
		List<Informes> filteredData = getDataForReports(filterInformes, tableRequestDto);
		String extension = null;

		// Comprobar si las siguientes variables estan vacias, en caso de estarlo se las
		// asigna un valor generico
		fileName = (fileName != null && !fileName.isEmpty()) ? fileName : "report";
		sheetTitle = (sheetTitle != null && !sheetTitle.isEmpty()) ? sheetTitle : Informes.class.getSimpleName();

		// Obtener el formato de fecha especifico del locale
		SimpleDateFormat formatter = DateTimeManager.getDateTimeFormat(request.getLocale());

		// Cuando no se definen columnas porque se quieren obtener todas
		if (columns == null) {
			Field[] fields = Informes.class.getDeclaredFields();
			ArrayList<String> tempColumns = new ArrayList<String>();

			for (int i = 0; i < fields.length; i++) {
				try {
					String methodName = fields[i].getName();
					methodName = methodName.substring(0, 1).toUpperCase() + methodName.substring(1);
					Informes.class.getMethod("get" + methodName);
					tempColumns.add(fields[i].getName());
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}

			}
			columns = tempColumns.toArray(new String[0]);
		}

		// si no se definen el nombre de las columnas , se dejan las de por defecto.
		if (columnsName == null) {
			columnsName = columns;
		}

		String servletPath = request.getServletPath();
		String reportType = null;
		if (servletPath.contains("/") && (servletPath.lastIndexOf("/") + 1 != servletPath.length())) {
			reportType = servletPath.substring(servletPath.lastIndexOf("/") + 1, servletPath.length());
		} else {
			reportType = servletPath.substring(0, servletPath.length());
		}

		if (reportType.equals("xlsReport")) {
			extension = ".xls";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("xlsxReport")) {
			extension = ".xlsx";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("pdfReport")) {
			extension = ".pdf";
			generatePDFReport(filteredData, columns, columnsName, fileName, response);
		} else if (reportType.equals("odsReport")) {
			extension = ".ods";
			generateODSReport(filteredData, columns, columnsName, fileName, sheetTitle, response);
		} else if (reportType.equals("csvReport")) {
			extension = ".csv";
			// Obtener idioma
			String language = request.getLocale().getLanguage();
			generateCSVReport(filteredData, columns, columnsName, fileName, sheetTitle, language, response);
		}

	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Informes>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param extension    String
	 * @param formatter    SimpleDateFormat
	 * @param response     HttpServletResponse
	 */
	private void generateExcelReport(List<Informes> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String extension, SimpleDateFormat formatter,
			HttpServletResponse response) {
		try {
			// Creacion del Excel
			Workbook workbook = null;
			if (extension == ".xlsx") {
				workbook = new XSSFWorkbook();
				response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			} else {
				workbook = new HSSFWorkbook();
				response.setContentType("application/vnd.ms-excel");
			}

			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + extension + "");

			// Creacion de una hoja y asignacion de su nombre
			Sheet sheet = workbook.createSheet(sheetTitle);

			// Se crea una fuente para estilizar las cabeceras
			Font headerFont = workbook.createFont();
			headerFont.setBold(true);
			headerFont.setFontHeightInPoints((short) 12);

			// Se crea un CellStyle con la fuente
			CellStyle headerCellStyle = workbook.createCellStyle();
			headerCellStyle.setAlignment(HorizontalAlignment.CENTER);
			headerCellStyle.setFont(headerFont);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Se crea la fila para insertar los titulos de las columnas
			Row row = sheet.createRow(rowNumber++);

			// Añadir titulos
			for (int i = 0; i < columnsName.length; i++) {
				Cell cell = row.createCell(i);
				cell.setCellValue(
						UtilLiterales.getLiteralMessage(appMessageSource, "excelReportLiteral." + columnsName[i]));
				cell.setCellStyle(headerCellStyle);
			}

			// CreationHelper ayudara a mantener la compatibilidad del DataFormat tanto si
			// se crea un .xls como un .xlsx
			CreationHelper createHelper = workbook.getCreationHelper();

			// Se crea un CellStyle para añadir el formateador de fechas
			CellStyle dateCellStyle = workbook.createCellStyle();
			dateCellStyle.setDataFormat(createHelper.createDataFormat().getFormat(formatter.toPattern()));

			// Añadir datos
			for (Informes rowInformes : filteredData) {
				int cellNumber = 0;
				row = sheet.createRow(rowNumber++);

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					Cell cellInformes = row.createCell(cellNumber++);
					cellInformes.setCellValue(getCellValue(column, rowInformes));
				}
			}

			// Se adapta el ancho de las columnas al contenido
			for (int i = 0; i < columns.length; i++) {
				sheet.autoSizeColumn(i);
			}

			// Se añade el fichero excel al response
			workbook.write(response.getOutputStream());
			workbook.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Informes>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param response     HttpServletResponse
	 */
	private void generatePDFReport(List<Informes> filteredData, String[] columns, String[] columnsName, String fileName,
			HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".pdf");
			response.setContentType("application/pdf");

			Document document = new Document();
			// Se añade el fichero pdf al response
			PdfWriter.getInstance(document, response.getOutputStream());

			document.open();

			PdfPTable table = new PdfPTable(columns.length);

			for (String column : columnsName) {
				PdfPCell header = new PdfPCell();
				header.setBorderWidth(2);
				header.setPhrase(new Phrase(column));
				table.addCell(header);
			}

			// Añadir datos
			for (Informes rowInformes : filteredData) {
				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					table.addCell(getCellValue(column, rowInformes));
				}
			}

			document.add(table);
			document.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Informes>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param response     HttpServletResponse
	 */
	private void generateODSReport(List<Informes> filteredData, String[] columns, String[] columnsName, String fileName,
			String sheetTitle, HttpServletResponse response) {
		try {
			// Se añade el fichero ods al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".ods");
			response.setContentType("application/vnd.oasis.opendocument.spreadsheet");

			OdfSpreadsheetDocument ods = OdfSpreadsheetDocument.newSpreadsheetDocument();
			ods.getOrCreateDocumentStyles();

			// Hay que eliminar la hoja que se genera por defecto
			ods.getTableByName("Sheet1").remove();

			// Hoja nueva
			OdfTable table = OdfTable.newTable(ods, filteredData.size() + 1, columns.length);
			table.setTableName(sheetTitle);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Cabeceras
			OdfTableRow row = table.getRowByIndex(rowNumber++);
			for (int i = 0; i < columnsName.length; i++) {
				row.getCellByIndex(i).setStringValue(columnsName[i]);
			}

			// Añadir datos
			for (Informes rowInformes : filteredData) {
				row = table.getRowByIndex(rowNumber++);
				int cellNumber = 0;

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					row.getCellByIndex(cellNumber++).setStringValue(getCellValue(column, rowInformes));
				}
			}

			// Se añade el fichero ods al response
			ods.save(response.getOutputStream());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Informes>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param language     String
	 * @param response     HttpServletResponse
	 */
	private void generateCSVReport(List<Informes> filteredData, String[] columns, String[] columnsName, String fileName,
			String sheetTitle, String language, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".csv");
			response.setContentType("text/csv");

			// Separador de campos dependiendo del idioma
			String separator = ";";
			if (language.equals("en")) {
				separator = ",";
			}

			// Se añade el fichero csv al response
			OutputStream out = response.getOutputStream();
			// Añadir titulos
			boolean addTitles = true;

			// Añadir datos
			for (Informes rowInformes : filteredData) {
				int cellNumber = 1;
				StringBuilder columnsTitles = new StringBuilder();
				StringBuilder row = new StringBuilder();

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					String cellValue = getCellValue(column, rowInformes);

					if (cellNumber < columns.length) {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"");
							columnsTitles.append(separator);
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"");
						row.append(separator);
						cellNumber++;
					} else {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"\n");
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"\n");
					}
				}

				if (addTitles) {
					out.write(columnsTitles.toString().getBytes());
					addTitles = false;
				}
				out.write(row.toString().getBytes());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve los datos recuperados de la DB.
	 *
	 * @param filterInformes  Informes
	 * @param tableRequestDto TableRequestDto
	 */
	private List<Informes> getDataForReports(Informes filterInformes, TableRequestDto tableRequestDto) {
		if (tableRequestDto.getMultiselection().getSelectedAll()
				&& tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			if (filterInformes != null) {
				return this.informesDao.findAllLike(filterInformes, tableRequestDto, false);
			} else {
				return this.informesDao.findAll(new Informes(), null);
			}
		} else {
			return this.informesDao.getMultiple(filterInformes, tableRequestDto, false);
		}
	}

	/**
	 * Obtiene los valores de las celdas.
	 *
	 * @param column      String
	 * @param rowInformes Informes
	 */
	private String getCellValue(String column, Informes rowInformes) {
		String cellValue = "";
		try {
			cellValue = BeanUtils.getProperty(rowInformes, column) != null ? BeanUtils.getProperty(rowInformes, column)
					: "";
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		}

		return cellValue;
	}

	public List<Informes> informesComplete(Informes filterInformes, TableRequestDto tableRequestDto) {
		List<Informes> listaInformes = this.informesDao.filterComplete(filterInformes, tableRequestDto);
		return listaInformes;
	}

	public List<Informes> informesCompleteNoInfSoc(Informes filterInformes) {
		List<Informes> listaInformes = this.informesDao.filterCompleteNoInfSoc(filterInformes);
		return listaInformes;
	}

	@Transactional(rollbackFor = Throwable.class)
	public InformeSocial updateInformeSocial(Informes informes) {

		// si no tiene idSolicitante01 es que no era beneficiario tenemos que guardar el
		// dni en el informe social
		if (!Utilidades.esNulo(informes.getSolicitantes())
				&& Utilidades.esNulo(informes.getSolicitantes().getIdSolicitante01())) {
			informes.getInformeSocial().setIdentificador02(informes.getSolicitantes().getIdentificador01());
		}

		informes = this.informesDao.updateInforme(informes);

		// El ayutamiento está asociado al usuario del informe en vez de al informe
		// social
//		informes.getInformeSocial().setAyuntamiento(informes.getUsuario().getAyuntamiento());
		// TODO: comprobar que se actualiza correctamente
		informes.setAyuntamiento(informes.getUsuario().getAyuntamiento());
		if (informes.getInformeSocial() != null) {
			informes.getInformeSocial().setfInforme02(UtilidadesFecha.getFechaSistema());
			if (null != informes.getSolicitantes().getApellido101()) {
				informes.getInformeSocial().setApellido102(informes.getSolicitantes().getApellido101());
			}
			if (null != informes.getSolicitantes().getApellido201()) {
				informes.getInformeSocial().setApellido202(informes.getSolicitantes().getApellido201());
			}
			if (null != informes.getSolicitantes().getNombre01()) {
				informes.getInformeSocial().setNombre02(informes.getSolicitantes().getNombre01());
			}
			if (null != informes.getSolicitantes().getIdentificador01()) {
				informes.getInformeSocial().setIdentificador02(informes.getSolicitantes().getIdentificador01());
			}
			if (null != informes.getSolicitantes().getTipoIdentificador01()) {
				informes.getInformeSocial().setTipoIdentificador02(informes.getSolicitantes().getTipoIdentificador01());
			}
		}
		return this.informeSocialDao.update(informes.getInformeSocial());
	}

	@Transactional(rollbackFor = Throwable.class)
	public Informes insertInformeSocial(Informes informes) {
//		informes.getInformeSocial().setMaestroTrSociales(informes.getMaestroTrSociales());
		// informes.setObservaciones16(informes.getInformeSocial().getObservaciones02());

		// si no tiene idSolicitante01 es que no era beneficiario tenemos que guardar el
		// dni en el informe social
		if (!Utilidades.esNulo(informes.getSolicitantes())
				&& Utilidades.esNulo(informes.getSolicitantes().getIdSolicitante01())) {
			informes.getInformeSocial().setIdentificador02(informes.getSolicitantes().getIdentificador01());
		}
		informes.setOrigen16(com.ejie.ad74a.util.constantes.Constantes.OrigenInformeSocialEnum.SSB.getId());

		informes.getInformeSocial().setUsuAlta02(UtilSeguridad.getUsuarioConectado().getUserName());
		informes = this.informesDao.addInformeSocial(informes);
		informes = this.informeSocialDao.addInformeInformeSocial(informes);
		List<ConvivientesInfSoci> convivientesAux = new ArrayList<ConvivientesInfSoci>();
		for (ConvivientesInfSoci conviviente : informes.getInformeSocial().getConvivientes()) {
			conviviente.setIdInfSocial82(informes.getInformeSocial().getIdInfSocial02());
			conviviente.setUsuAlta82(UtilSeguridad.getNameUsuarioConectado());
			ConvivientesInfSoci convivienteAux = this.convivientesInfSociService.add(conviviente);
			convivientesAux.add(convivienteAux);
		}
		informes.getInformeSocial().setConvivientes(convivientesAux);

		return informes;
	}

	/**
	 * Busca si existe un informe social asociado al dni del solicitante y que no
	 * tenga expediente asociado
	 * 
	 * @param nif
	 * @param match
	 * @return Informes
	 */
	@Override
	public Informes getInformeSocialSinMatchByNIF(String nif, Boolean match) {
		InformesServiceImpl.logger
				.debug("InformesServiceImpl getInformeSocialSinMatchByNIF Inicio nif: " + nif + " - match:" + match);
		InformeSocial informeSocial = new InformeSocial();
		informeSocial.setIdentificador02(nif);
		Informes informes = new Informes();
		informes.setMatch(match);
		informes.setInformeSocial(informeSocial);
		informes.setEstado16(EstadoInformesEnum.ENVIADO.getId());

		List<Informes> informesList = this.informesComplete(informes, null);
		if (!informesList.isEmpty() && informesList.get(0).getIdExpediente16() == null) {
			InformesServiceImpl.logger
					.debug("InformesServiceImpl getInformeSocialSinMatchByNIF Fin Informe Encontrado: "
							+ informesList.get(0).toString());
			return informesList.get(0);
		}
		InformesServiceImpl.logger
				.debug("InformesServiceImpl getInformeSocialSinMatchByNIF Fin Sin Informe Encontrado: ");
		return null;
	}

	public Informes ocultar(Informes informes) {
		return this.informesDao.ocultar(informes);

	}

	public Informes mostrar(Informes informes) {
		return this.informesDao.mostrar(informes);

	}

	@Override
	public Informes obtenerInforme(Informes informes) {
		return this.informesDao.obtenerInforme(informes);
	}

	@Transactional(rollbackFor = Throwable.class)
	public Informes updateDocInforme(Informes informes) {
		return this.informesDao.updateDocInforme(informes);
	}

	@Transactional(rollbackFor = Throwable.class)
	public Informes aportar(Informes informes, MultipartFile documento) {

		List<Informes> informesList = this.informesComplete(informes, null);
		Informes informeAux = new Informes();
//		if (!informesList.isEmpty() && informesList.get(0).getIdExpediente16() == null) {
		if (!informesList.isEmpty()) {
			informeAux = informesList.get(0);
		}

		// Subir a PIF
		String rutaPif = "";
		try {
			InputStream inputStream = new BufferedInputStream(documento.getInputStream());
			String pathDocumento = com.ejie.ad74a.constantes.Constantes.RUTA_PID
					.concat(Constantes.COD_APLICACION.toLowerCase()).concat("/")
					.concat(documento.getOriginalFilename());
			rutaPif = Ad74aPIFws.getInstance().uploadDocument(inputStream, pathDocumento, true);
			inputStream.close();
		} catch (Exception e) {
			ManagerErrors.manageException(e, "ERROR subiendo documento aportar al informe a PIF");
		}

		// Subir a PID
		String nombreFichero = documento.getOriginalFilename();
		// String usuarioAlta = UtilSeguridad.getUsuarioConectado().getUserName();
		String usuarioAlta = Constantes.COD_APLICACION;
		String aplic = Constantes.COD_APLICACION;
		String rutaPid = pidWS.put(aplic, nombreFichero, rutaPif, usuarioAlta);

		// Insertar documento
		DocumentosInforme docInforme = new DocumentosInforme();
		if (informeAux.getTipoInforme16().equalsIgnoreCase(TipoInformesEnum.INFSOC.getId())) {
			docInforme.setIdTipoDoc17(TiposDocumentoRoleEnum.INFORME_SOCIAL.getId());
		} else if (informeAux.getTipoInforme16().equalsIgnoreCase(TipoInformesEnum.INFINT.getId())) {
			// TODO: ver cómo tipìfica el informe de intervenciones
			docInforme.setIdTipoDoc17(TiposDocumentoRoleEnum.INFORME_INTERVENCION.getId());
			informeAux.setObservaciones16("prueba imanol");
		} else if (informeAux.getTipoInforme16().equalsIgnoreCase(TipoInformesEnum.INFSUM.getId())) {
			// TODO: ver cómo tipificar el informe de malos tratos y suicidio
			docInforme.setIdTipoDoc17(TiposDocumentoRoleEnum.OTROS.getId());
		}
		docInforme.setUsuAlta17(UtilSeguridad.getUsuarioConectado().getUserName());
		// docInforme.setUrlRuta17(rutaPif);
		docInforme.setOid17(rutaPid);
		docInforme.setNombreDoc17(documento.getOriginalFilename());
		documentosInformeService.add(docInforme);

		informeAux.setDocumentosInforme(docInforme);
		informeAux.setEstado16(EstadoInformesEnum.PENDIENTE_ENVIAR.getId());
		return this.informesDao.aportar(informeAux);

	}

	@Transactional(rollbackFor = Throwable.class)
	public Informes eliminar(Informes informes) {
		InformeSocial infSoc = new InformeSocial();
		infSoc.setIdInforme02(informes.getIdInforme16());
		List<InformeSocial> listinfSoc = this.informeSocialService.findAllLike(infSoc, null, false);
		return this.informesDao.eliminar(informes, listinfSoc.get(0));

	}

	@Transactional(rollbackFor = Throwable.class)
	public Informes enviarDSS(Informes informes, HttpServletRequest request) {

		try {
			List<Informes> informesList = this.informesDao.filterComplete(informes, null);
			if (!informesList.isEmpty()) {
				informes = informesList.get(0);
				if ((TipoInformesEnum.INFSOC.getId().equals(informes.getTipoInforme16())
						&& informes.getIdExpediente16() != null)
						|| TipoInformesEnum.INFINT.getId().equals(informes.getTipoInforme16())
						|| TipoInformesEnum.INFSUM.getId().equals(informes.getTipoInforme16())) {

					Avisos aviso = new Avisos();
					if (TipoInformesEnum.INFSOC.getId().equals(informes.getTipoInforme16())) {
						aviso.setMaestroTiposAviso(new MaestroTiposAviso(TipoAvisoEnum.INFSOC.getIdLongValue()));
						aviso.setMaestroSubtiposAviso(
								new MaestroSubtiposAviso(SubTipoAvisoEnum.ENVEXPAB.getIdLongValue()));
						aviso.setObservaciones20(informes.getInformeSocial().getObservaciones02());
					} else if (TipoInformesEnum.INFINT.getId().equals(informes.getTipoInforme16())) {
						aviso.setMaestroTiposAviso(new MaestroTiposAviso(TipoAvisoEnum.INFINT.getIdLongValue()));
						aviso.setMaestroSubtiposAviso(
								new MaestroSubtiposAviso(SubTipoAvisoEnum.ENVDSS.getIdLongValue()));
						aviso.setObservaciones20(informes.getObservaciones16());
					} else if (TipoInformesEnum.INFSUM.getId().equals(informes.getTipoInforme16())) {
						aviso.setMaestroTiposAviso(new MaestroTiposAviso(TipoAvisoEnum.INFSUIC.getIdLongValue()));
						aviso.setMaestroSubtiposAviso(
								new MaestroSubtiposAviso(SubTipoAvisoEnum.ENVDSSSUIC.getIdLongValue()));
						aviso.setObservaciones20(informes.getObservaciones16());
					}
					// aviso.setMaestroSubtiposAviso(new
					// MaestroSubtiposAviso(SubTipoAvisoEnum.ENVDSS.getIdLongValue()));
					aviso.setMaestroActoresByDestino20(new MaestroActores(ActoresEnum.DSS.getId()));
					if (UtilSeguridad.isSSB(request)) {
						aviso.setMaestroActoresByOrigen20(new MaestroActores(ActoresEnum.SSB.getId()));
					} else if (UtilSeguridad.isPS(request) || UtilSeguridad.isAdmin(request)) {
						aviso.setMaestroActoresByOrigen20(new MaestroActores(ActoresEnum.PS.getId()));
					}
					aviso.setIdSolicitante20(informes.getSolicitantes().getIdSolicitante01());
					aviso.setUrgencia20(informes.getUrgente16() != null && informes.getUrgente16() > 0);
					aviso.setUsuAlta20(com.ejie.ad74a.constantes.Constantes.COD_APLICACION);
					// relacionamos el aviso con el informe
					aviso.setIdInforme20(informes.getIdInforme16());
					aviso = this.avisosService.insertAvisos(aviso);

					DocuAvisos docuAvisos = new DocuAvisos();
					docuAvisos.setIdAviso70(aviso.getIdAviso20());
					docuAvisos.setRuta70(informes.getDocumentosInforme().getOid17());
					docuAvisos.setNombreDoc70(informes.getDocumentosInforme().getNombreDoc17());
					docuAvisos.setExtension70(getExtension(informes.getDocumentosInforme().getNombreDoc17()));
					docuAvisos.setUsuAlta70(informes.getDocumentosInforme().getUsuAlta17());
					docuAvisos.setfecAlta70(informes.getDocumentosInforme().getfAlta17());
					docuAvisos.setIdTipoDoc70(informes.getDocumentosInforme().getIdTipoDoc17());
					docuAvisosService.add(docuAvisos);
				}

				informes.setEstado16(EstadoInformesEnum.ENVIADO.getId());
				informes.setfEnvioAdmon16(new Date());
				informes.setUsuModif16(UtilSeguridad.getUsuarioConectado().getUserName());

				this.informesDao.updateEstado(informes);
				return this.informesDao.updateEnvioAdmon(informes);
			} else {
				throw new Exception("Informe no encontrado");
			}
		} catch (Exception e) {
			ManagerErrors.manageException(e, "ERROR enviando el informe a la DSS");
		}

		return informes;

	}

	@Override
	public Informes updateEstado(Informes informes) {
		return this.informesDao.updateEstado(informes);
	}

	@Override
	public Informes updateEnvioAdmon(Informes informes) {
		return this.informesDao.updateEnvioAdmon(informes);
	}

	@Override
	public Informes borrarDocumento(Informes informes) {
		informes.setEstado16(EstadoInformesEnum.PENDIENTE_APORTAR.getId());
		informes.setUsuModif16(UtilSeguridad.getUsuarioConectado().getUserName());
		// TODO: borrar documento de PID

		try {
			DocumentosInforme documento = documentosInformeService.find(informes.getDocumentosInforme());
			Boolean deleted = pidWS.delete(documento.getOid17());
			if (deleted) {
				this.informesDao.borrarDocumento(informes);
			} else {
				throw new Exception("No se ha podico borrar el documento");
			}
		} catch (Exception e) {
			ManagerErrors.manageException(e, "ERROR borrando el documento");
		}
		return informes;
	}

	@Override
	@Transactional(rollbackFor = Throwable.class)
	public Informes relacionInformePorMatch(Informes informes, Expedientes expediente) {

		InformesServiceImpl.logger.info("InformesServiceImpl.relacionInformePorMatch - Inicio");

		this.informesDao.relacionInformePorMatch(informes);

		DocumentosInforme docInform = informes.getDocumentosInforme();
		if (null != docInform && null != docInform.getIdDocInforme17()
				&& !Utilidades.esBlancoNulo(docInform.getOid17())) {

			InformesServiceImpl.logger
					.info("InformesServiceImpl.getInformeSocialSinMatchByNIF - Se hace la aportacion oid:"
							+ docInform.getOid17());

			DocTemporales docTemp = new DocTemporales();
			docTemp.setNombreDoc72(docInform.getNombreDoc17());
			docTemp.setRutapif72(docInform.getUrlRuta17());
			docTemp.setOid72(docInform.getOid17());
			docTemp.setFolderId72(expediente.getFolderId00());
			docTemp.setUsuAportacion72(UtilSeguridad.getNameUsuarioConectado());
			docTemp.setIdTipoDoc72(docInform.getIdTipoDoc17());
			docTemp.setExterno72(1);
			this.documentosService.aportarDocumento(docTemp);

		}
		InformesServiceImpl.logger.info("InformesServiceImpl.relacionInformePorMatch - Fin");
		return informes;
	}

	public Informes addDesdeAvisos(Informes informes) {
		return this.informesDao.addDesdeAvisos(informes);
	}

	private String getExtension(String nombreDoc) {
		String ext = "";
		if (!Utilidades.esBlancoNulo(nombreDoc)) {
			String[] part = nombreDoc.split("\\.");
			if (part.length > 1) {
				ext = part[part.length - 1];
			}
		}
		return ext;
	}

}
